searchData={"content_type":"text/markdown","items":[{"doc":"","ref":"Ueberauth.Strategy.Duo.html","title":"Ueberauth.Strategy.Duo","type":"module"},{"doc":"Includes the credentials from the Duo response.","ref":"Ueberauth.Strategy.Duo.html#credentials/1","title":"Ueberauth.Strategy.Duo.credentials/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Duo.html#default_options/0","title":"Ueberauth.Strategy.Duo.default_options/0","type":"function"},{"doc":"Stores the raw information (including the token) obtained from the Duo callback.","ref":"Ueberauth.Strategy.Duo.html#extra/1","title":"Ueberauth.Strategy.Duo.extra/1","type":"function"},{"doc":"Cleans up the private area of the connection used for passing the raw Duo response around during the callback.","ref":"Ueberauth.Strategy.Duo.html#handle_cleanup!/1","title":"Ueberauth.Strategy.Duo.handle_cleanup!/1","type":"function"},{"doc":"Fetches the fields to populate the info section of the `Ueberauth.Auth` struct.","ref":"Ueberauth.Strategy.Duo.html#info/1","title":"Ueberauth.Strategy.Duo.info/1","type":"function"},{"doc":"Fetches the uid field from the Duo response. This defaults to the option `uid_field` which in-turn defaults to `sub`","ref":"Ueberauth.Strategy.Duo.html#uid/1","title":"Ueberauth.Strategy.Duo.uid/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Duo.OAuth.html","title":"Ueberauth.Strategy.Duo.OAuth","type":"module"},{"doc":"","ref":"Ueberauth.Strategy.Duo.OAuth.html#authorize_url/2","title":"Ueberauth.Strategy.Duo.OAuth.authorize_url/2","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Duo.OAuth.html#authorize_url!/2","title":"Ueberauth.Strategy.Duo.OAuth.authorize_url!/2","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Duo.OAuth.html#client/1","title":"Ueberauth.Strategy.Duo.OAuth.client/1","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Duo.OAuth.html#get_token/3","title":"Ueberauth.Strategy.Duo.OAuth.get_token/3","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Duo.OAuth.html#get_token!/2","title":"Ueberauth.Strategy.Duo.OAuth.get_token!/2","type":"function"},{"doc":"","ref":"Ueberauth.Strategy.Duo.OAuth.html#get_user_info/2","title":"Ueberauth.Strategy.Duo.OAuth.get_user_info/2","type":"function"},{"doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"- Initial semantic release","ref":"changelog.html#v0-1-0-2023-11-20","title":"v0.1.0 - 2023-11-20 - Changelog","type":"extras"},{"doc":"# MIT License\n\nCopyright (c) 2023 synclinical\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"# ueberauth_duo\n\n> Cisco Duo OAuth2 strategy for Überauth.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"1.  Set up your Duo OICD application by following these [instructions](https://duo.com/docs/sso-oidc-generic).\n\n2.  Add `:ueberauth_duo` to your list of dependencies in `mix.exs`:\n\n    ```elixir\n    def deps do\n      [\n        {:ueberauth_duo, \"~> 1.0\"}\n      ]\n    end\n    ```\n\n3.  Ensure `ueberauth_duo` is started before your application:\n\n    ```elixir\n    def application do\n      [\n        extra_applications: [:ueberauth_duo]\n      ]\n    end\n    ```\n\n4.  Add Duo to your Überauth configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth,\n      providers: [\n        duo: {Ueberauth.Strategy.Duo, []}\n      ],\n    ```\n\n5.  Update your provider configuration:\n\n    ```elixir\n    config :ueberauth, Ueberauth.Strategy.Duo.OAuth,\n      site: System.get_env(\"DUO_SITE\"),\n      client_id: System.get_env(\"DUO_CLIENT_ID\"),\n      client_secret: System.get_env(\"DUO_CLIENT_SECRET\")\n    ```\n\n6.  Include the Überauth plug in your controller:\n\n    ```elixir\n    defmodule MyApp.AuthController do\n      use MyApp.Web, :controller\n      plug Ueberauth\n      ...\n    end\n    ```\n7.  Create the request and callback routes if you haven't already:\n\n    ```elixir\n    scope \"/auth\", MyApp do\n      pipe_through :browser\n\n      get \"/:provider\", AuthController, :request\n      get \"/:provider/callback\", AuthController, :callback\n    end\n    ```\n\n8. You controller needs to implement callbacks to deal with Ueberauth.Auth and Ueberauth.Failure responses.\n\nFor an example implementation see the [Überauth Example](https://github.com/ueberauth/ueberauth_example) application.","ref":"readme.html#installation","title":"Installation - Overview","type":"extras"},{"doc":"This library is basically a copy and paste of the [Okta](https://github.com/appcues/ueberauth_okta) and [Microsoft](https://github.com/swelham/ueberauth_microsoft) Ueberauth strategies, and would not be possible without them. Thank you to the good people at [Appcues](https://www.appcues.com/) and to [Stuart Welham](https://github.com/swelham) for all your hard work.","ref":"readme.html#thanks","title":"Thanks! - Overview","type":"extras"},{"doc":"[OAuth2 explained with cute shapes](https://engineering.backmarket.com/oauth2-explained-with-cute-shapes-7eae51f20d38)","ref":"readme.html#learn-about-oauth2","title":"Learn about OAuth2 - Overview","type":"extras"},{"doc":"Copyright (c) 2023 Peter Lacey\n\nThis library is released under the MIT License. See the [LICENSE.md](./LICENSE.md) file\nfor further details.","ref":"readme.html#copyright-and-license","title":"Copyright and License - Overview","type":"extras"}]}